/* Version: 1.0.60 - June 15, 2022 18:23:27 */
(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory() :
  typeof define === 'function' && define.amd ? define(factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, global.Opay2 = factory());
})(this, (function () { 'use strict';

  //import {qrcode} from "./qrcode.js"
  var isBrowser = new Function('try {return this===window;}catch(e){ return false;}');
  var g_isBrowser = isBrowser();
  var fetch;
  const IDS = {
    main: "_opay_main",
    all: "_opay_all",
    close: "_opay_close",
    vbox: "_opay_vbox",
    dot: "_opay_dot"
  };
  const SS = {
    content: "content",
    btn: "__class_btn"
  };
  const payhtml = `
<div id=${IDS.all} style="display:none;width:100%;height:100%;position:relative;top:0;left:0">
<style scoped>
.${SS.content} {
  height: 100%;
  display: flex;
  border:1px solid gray;
  flex-direction: column;
  box-sizing: border-box;
  background: #eee;
}
.${SS.content} .header {
  height: 30px;
  line-height: 30px;
  text-align: center;
}
.${SS.content} .main {
  display: flex;
  align-items: center;
  flex-direction: row;
  height: 100%;
}
.${SS.content} .wallet {
  width: 50%;
  height: 80%;
  border-right: 1px solid #ddd;
  display: flex;
  flex-direction: column;
}
.${SS.content} .witem {
  flex: 1;
  margin: 20px 10px;
  text-align: center;
}
.${SS.content} .${SS.btn} {
  background-color: DodgerBlue;
  border: none;
  /* Remove borders */
  color: white;
  /* White text */
  cursor: pointer;
  width: 80%;
  padding: 10px 10px;
}
.${SS.content} .qr {
  width: 50%;
  align-items: center;
  align-content: center;
}
.${SS.content} .qr img {
  margin-left: auto;
  margin-right: auto;
  display: block;
} 
</style>
  
  
<main class=${SS.content} id=${IDS.main}>

  <div class="header" ><span tid="title">Click Wallet or Scan QR</span>  <span align="right" style="float: right;cursor: pointer;"  id=${IDS.close}>✖</span></div>
 
           <div class="main">
            <div class="wallet">
              <div class="witem">
                <button class=${SS.btn} id=${IDS.vbox} tid="vbox">VBox</button>
                <div style="font-size:10px;color:red;display:none" id="_opay_no_vbox" tid="vinstall">Not found, click to install</div>
              </div>
              <div class="witem"><button class=${SS.btn} id=${IDS.dot} tid="dot">DotWallet</button></div>
            </div>
             <div class="qr"><div id="_opay_qrcode" align="center"></div></div>
            </div>
            <span align="right" style="float: right;cursor: pointer;color: lightgray;" onclick="window.open('https://nbdomain-doc.glitch.me/#/help?id=_2-what-wallet-can-be-used-with-nbdomain','target=_blank')">❓</span>
</main>
</div>
`;
  const loginHTML = `
<style scoped>
/* Page Overlay */

._opay_popUpForm {
  display: block;
  min-width: 400px;
  height: auto;
  font-size: 20px;
  line-height: 18px;
  background: #eee;
  position: fixed;
  left: 50%;
  top: 40%;
  margin-left: -190px;
  box-shadow: 3px 3px 3px #000;
  border-radius: 5px;
  text-align: center;
  z-index: 11000;
}
._opay_closeButton {
    margin: 5px;
    cursor: pointer;
    float: right;
  }
._opay_nextButton{
    background-color: DodgerBlue;
    border: none;
    color: white;
    cursor: pointer;
    padding: 10px 20px;
    border: 0;
    border-radius: 5px;
  }
._opay_page2 {
  display: none;
  width: 100%;
  height: auto;
}
._opay_pageOverlay {
  position: fixed;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
  opacity: 0.5;
  background: #000;
  z-index: 10000;
}
</style>
 <div class="_opay_popUpForm" id="id_opay_popUpForm">
     <div class="_opay_closeButton">
        ✖
      </div>
      <div class="_opay_page1" style="margin:15px;">
     
      <div style="text-align:center;font-size:30px;line-height:40px;" tid="login">
        Sign in
      </div>  
      <div style="margin:20px;">
        <span>NBdomain:</span>
        <input type="text" style="height:25px;padding:3px 10px;" id="_opay_idomain" />
        <div id="_opay_error"  style="color:red;display:none;font-size:15px;"></div>
      </div>
      
      <button id="_opay_nextButton" class="_opay_nextButton" tid="next">Next</button>
        </div>
      <div class="_opay_page2" style="margin:15px;">
        <div id="_opay_Opay" ></div>
        </div>
    </div> 
`;
  const payPopupHtml = `
<style scoped>
._opay_pageOverlay {
  position: fixed;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
  opacity: 0.5;
  background: #000;
  z-index: 1000;
}

#_opay_payPopup {
  display:flex;
  position:absolute;
  align-items: center;
  left: 50%; 
  top: 50%; 
  transform: translate(-50%, -50%);
  width: 30rem;
  z-index: 1100;
}
._opay_closeButton {
    margin: 5px;
    cursor: pointer;
    float: right;
  }

._qrcode{
  box-shadow: 0 4px 12px 0 rgb(37 41 46 / 25%);
  width:300px;
  height:300px;
  margin:20px auto;
}
._wallet{
  width:140px;
  height:180px;
  margin:50px auto;
}
._wallet ._icon{
  margin:5px 3px;
  width:96px;
  height:96px;
  box-shadow: 0 4px 12px 0 rgb(37 41 46 / 25%);
}
._subTitle{
  color: rgba(60, 66, 82, 0.6);
    font-size: 16px;
    font-weight: 600;
    letter-spacing: 0;
    line-height: 1.1875em;
    margin: 10px 0 20px 0;
    text-align: center;
    width: 100%;
}
._tabs {
  width: 100%;
  text-align:center;
  background-color: white;
  border-radius: 0.5rem;
  box-shadow: 0 5px 10px rgba(0, 0, 0, 0.25);
}

._tab-control {
  display: inline-block;
  text-align:center;
  border-bottom: 2px solid transparent;
  font-size: 1.25rem;
  padding: 0.6rem 2rem;
  cursor: pointer;
  transition: all 0.25s ease;
}

._tab-control:hover {
  color: #ed1e79;
}

._tab-content {
  border-top: 1px solid #ed1e79;
  padding: 1rem;
}

._tab-panel {
  display: none;
  height:400px;
}

/* Magic style */
input[type="radio"]:checked + ._tab-control {
  font-weight: 600;
  color: #ed1e79;
  border-bottom-color: #ed1e79;
}

#_tab-1:checked ~ ._tab-content > #_tab-panel-1 {
  display: block;
}

#_tab-2:checked ~ ._tab-content > #_tab-panel-2 {
  display: block;
}
</style>
<div id="_opay_payPopup">

  <div class="_tabs">
    <div class="_opay_closeButton">
        ✖
      </div>
    <input hidden type="radio" name="tab-css" id="_tab-1" checked />
    <label class="_tab-control" for="_tab-1" tid="qrPay">QR Code</label>
    <input hidden type="radio" name="tab-css" id="_tab-2" />
    <label class="_tab-control" for="_tab-2" tid="desktop">Desktop</label>
  
    <div class="_tab-content">
      <div id="_tab-panel-1" class="_tab-panel">
        <div class="_subTitle" tid="title_qr_panel">Scan QR code with an OPay compatible wallet 
        </div>
        <img id="_opay_qrcode" class="_qrcode"></img>
      </div>
      <div id="_tab-panel-2" class="_tab-panel">
        <div class="_subTitle" tid="title_desktop_panel">
          Choose your prefered Wallet
        </div>
        <div class="_wallet">
        <img id="_vboxWallet" src="$scriptPath$vbox-icon.png" class="_icon"/><p>VBox</p></div>
      </div>
      
    </div>
  </div>
</div>
`;
  let _default = {
    product: "OPay Product",
    timeout: 5 * 60,
    app: {
      name: "Opay App"
    },
    debug: false,
    handshake: null,
    child: null,
    event_on: false,
    cb: null,
    debug: false,
    expireObj: {},
    current_orderID: 0,
    wallet: null,
    UI: {
      close: true
    }
  };
  const scriptPath = g_isBrowser ? document && document.currentScript.src : null;
  let relayServer = "https://tnode.nbdomain.com/api/"; //let relayServer = "http://localhost:9001/api/";

  let log = console.log;
  let Page = {};

  async function loadScript(url) {
    return new Promise(resolve => {
      var script = document.createElement("script");
      script.type = "text/javascript";

      script.onload = function () {
        resolve(true);
      };

      script.onerror = () => {
        console.error("error loading" + url);
        resolve(false);
      };

      script.src = url;
      document.getElementsByTagName("head")[0].appendChild(script);
    });
  }

  class Opay2 {
    static async loginPopup(options, cb) {
      let nbNode = options && options.nbnode ? options.nbnode : "https://api.nbdomain.com/";
      const opayLogin = new Opay2();
      await opayLogin.init({
        debug: true
      });
      if (nbNode.substr(-1) != '/') nbNode += "/";
      let emPopup = document.querySelector("._opay_popUpForm");

      if (!emPopup) {
        emPopup = document.createElement('div');
        emPopup.innerHTML = loginHTML;
        document.body.appendChild(emPopup);
      }

      $("body").append('<div class="_opay_pageOverlay"></div>');
      const emPage1 = document.querySelector("._opay_page1");
      const emPage2 = document.querySelector("._opay_page2");
      if (emPage1) emPage1.style.display = 'block';
      if (emPage2) emPage2.style.display = 'none';
      opayLogin.translate("id_opay_popUpForm");
      emPopup.style.display = 'block';
      opayLogin.setUI({
        close: false,
        border: "0px"
      });

      function closePopup() {
        $("._opay_popUpForm").hide();
        $("._opay_pageOverlay").hide();
        opayLogin.close();
      }

      $("#_opay_nextButton").on('click', async function (e) {
        e.stopPropagation();
        const url = nbNode + "api/?nid=" + $("#_opay_idomain").val();
        const res = await (await fetch(url)).json();

        if (res.code != 0) {
          $("#_opay_error").text("This domain is not registered");
          $("#_opay_error").show();
          setTimeout(() => {
            $("#_opay_error").hide();
          }, 2000);
          return;
        }

        $("._opay_page1").hide();
        $("._opay_page2").show();
        let hash1 = opayLogin.sha256(Date.now().toString());
        let RequestBody = {
          signer: res.obj.owner,
          data_hash: hash1
        };
        let req = {
          sign_request: {
            data: RequestBody
          },
          containerID: "_opay_Opay"
        };
        opayLogin.request(req, retObj => {
          let ret = res;

          if (retObj.code == 0) {
            const signed = retObj.body;
            opayLogin.verify(hash1, signed, res.obj.owner_key);
          } else {
            ret = {
              code: 1,
              message: retObj.message,
              domain: res.domain
            };
          }

          cb && cb(ret);
          closePopup();
        });
      }); // Close button

      $("._opay_closeButton").on("click", closePopup);
    }

    async pay(req, cb) {
      const options = {
        pay_request: {
          data: req
        }
      };
      return await this._request(options, cb);
    }

    async sign(req, cb) {
      const options = {
        sign_request: {
          data: req
        }
      };
      return await this._request(options, cb);
    }

    async _request(options, cb) {
      const opayLogin = this;
      if (!this.opay_inited) await opayLogin.init({
        debug: true
      });

      if (!g_isBrowser || this.GG.wallet) {
        return await opayLogin.request(options, cb);
      }

      let emPopup = document.querySelector("#_opay_payPopup");

      if (!emPopup) {
        let src = scriptPath;
        src = src.slice(0, src.lastIndexOf('/') + 1);
        const html = payPopupHtml.replace("$scriptPath$", src);
        emPopup = document.createElement('div');
        emPopup.innerHTML = html;
        document.body.appendChild(emPopup);
        emPopup = document.querySelector("#_opay_payPopup");
      } else {
        emPopup.style.display = 'flex';
      }

      $("body").append('<div class="_opay_pageOverlay"></div>');
      opayLogin.translate("_opay_payPopup");
      opayLogin.genQRImg(options, "_opay_qrcode", res => {
        closePopup();
        cb(res);
      });

      function closePopup() {
        //emPopup.style.display = 'none';
        $("#_opay_payPopup").hide();
        $("._opay_pageOverlay").hide();
      } //vbox button


      $("#_vboxWallet").on("click", () => {
        opayLogin.callWallet("vbox");
      }); // Close button

      $("._opay_closeButton").on("click", () => {
        closePopup();
        opayLogin.close();
      });
    }

    async init(option) {
      this.GG = { ..._default,
        ...option
      };

      if (!option.debug) {
        log = msg => {};
      }

      log("opay init option=", option);

      if (option.nbAPI) {
        relayServer = option.nbAPI;
      }

      if (this.GG.relaySever) {
        relayServer = this.GG.relaySever;
      }

      if (this.opay_inited) return;
      console.log('Opay2: 1.0.60 - June 15, 2022 18:23:27');
      await this._initLibs();
      this.opay_inited = true;
    }

    setRelay(url) {
      relayServer = url;
    }

    async _initLibs() {
      console.log("isBrowser:", g_isBrowser);

      if (!g_isBrowser) {
        //bsv = require('bsv')
        fetch = require('cross-fetch');
        return;
      }

      fetch = window.fetch;
      /*if (!window.nbpay) {
        log("loading nbpay");
        await loadScript("https://unpkg.com/nbpay@latest/dist/nbpay.min.js");
        if (window.nbpay) {
            bsv = window.nbpay.bsv;
            log("nbpay loaded:", window.nbpay);
        } else {
              log("nbpay failed to load");
        }
          
      } else {
        bsv = window.nbpay.bsv;
      } */

      if (!window.cash && !window.jQuery) {
        if (await loadScript("https://unpkg.com/opay2@latest/cash.min.js")) log("cash lib loaded");
      }

      log('loading qrcode');

      if (!window.qrcode) {
        if (await loadScript("https://unpkg.com/opay2@latest/qrcode.min.js")) log("qrcode lib loaded");
      }
    }

    translate(parentID) {
      if (navigator.language.toLowerCase() != "zh-cn") return;
      var cntext = {
        webPay: "网页",
        qrPay: "扫码支付",
        desktop: "桌面",
        vbox: "傲游 VBox",
        dot: "打点钱包",
        title: "点击钱包或扫码",
        vinstall: "未检测到，点击安装",
        login: "登录",
        next: "下一步",
        title_qr_panel: "请使用OPay兼容钱包扫描",
        title_desktop_panel: "请点击钱包"
      };
      var items = document.getElementById(parentID).querySelectorAll("[tid]");

      for (let i = 0; i < items.length; i++) {
        const item = items[i];
        const tid = item.attributes['tid'].value;
        item.innerText = cntext[tid];
      }
    }

    clearChecker(orderID) {
      log("in clearChecker");
      const checkingObj = this.GG.expireObj[orderID];

      if (checkingObj) {
        log("clearChecker timeoutID:", checkingObj.timeoutID);
        this.GG.expireObj[orderID] = null;
        return true;
      }

      return false;
    }

    async checkReturn(ID) {
      //const domain = document.location.origin;
      log("checker:", this.GG.expireObj, "ID:", ID);
      const checkingObj = this.GG.expireObj[ID];

      if (checkingObj == null) {
        log("no checkingObj");
        return;
      }

      const time_now = Date.now();

      if (time_now > checkingObj.expire) {
        this.clearChecker(ID);
        return;
      }

      const replyURL = relayServer + "relay/get/" + ID + "?notify=1";
      log(replyURL);
      const res = await fetch(replyURL);
      const data = await res.text();
      log(data);

      if (data != "404") {
        await this.handle_result(false, data);
      } else {
        log("continue to check");
        checkingObj.timeoutID = setTimeout(this.checkReturn.bind(this), 2000, ID);
      }

      return data;
    }

    async handle_result(bVbox, data) {
      if (!this.clearChecker(this.GG.current_orderID) && !bVbox) return; //found re-entry,return

      const json = JSON.parse(data);
      json.usedWallet = this.usedWallet;
      log("got_reply1 data=", json, "isVbox:", bVbox);
      const ret = await this.cb(json);
      log("return from app:", ret);

      if (json.ack_url && ret) {
        let retAck = ret;
        retAck.id = json.id;
        const url = json.ack_url + "?ack=" + JSON.stringify(retAck);
        fetch(url);
      }

      this.handled = true;
      this.close();
    }

    _setupUI(qrString) {
      if (!g_isBrowser) return;

      if (!document.getElementById(IDS.all)) {
        const elm = document.getElementById(this.GG.containerID);
        elm.innerHTML = payhtml;
        this.containerID = this.GG.containerID;
        Page.emContainer = elm;
        Page.emAll = elm.querySelector("#" + IDS.all);
        Page.emMain = elm.querySelector("#" + IDS.main);
        Page.emClose = elm.querySelector("#" + IDS.close);
        Page.emClose && Page.emClose.addEventListener("click", this.close.bind(this), {
          passive: true
        });
        Page.emVbox = elm.querySelector("#" + IDS.vbox);
        Page.emDot = elm.querySelector("#" + IDS.dot);
        Page.emVbox && Page.emVbox.addEventListener("click", this.callWallet.bind(this, "vbox"), {
          passive: true
        });
        Page.emDot && Page.emDot.addEventListener("click", this.callWallet.bind(this, "dot"), {
          passive: true
        });
        this.translate(this.GG.containerID);

        if (typeof VBox == 'undefined') {
          elm.querySelector("#_opay_no_vbox").style.display = "block";
        }
      } else {
        this.changeContainer(this.GG.containerID);
      }

      if (this.GG.UI.close === false) {
        Page.emClose.style.display = "none";
      }

      if (this.GG.UI && this.GG.UI.border) {
        Page.emMain.style.border = this.GG.UI.border;
      }

      if (this.GG.UI && this.GG.UI.background) {
        Page.emMain.style.background = this.GG.UI.background;
      }

      if (qrString) {
        const strQR = qrString;
        var typeNumber = 0;
        var errorCorrectionLevel = "L";
        var qr = qrcode(typeNumber, errorCorrectionLevel);
        qr.addData(strQR);
        qr.make();
        let strImgTag = qr.createImgTag();
        Page.emContainer.querySelector("#_opay_qrcode").innerHTML = strImgTag;
      }
    }

    setWallet(wallet) {
      this.GG.wallet = wallet;
    }

    close() {
      if (!this.opay_inited) return;
      this.clearChecker(this.GG.current_orderID);

      if (!this.handled && this.cb) {
        this.cb({
          code: 1,
          message: "Canclled"
        });
      }

      if (Page.emAll) Page.emAll.style.display = "none";
    }

    setUI(UI) {
      this.GG.UI = UI;
    }

    changeContainer(ID) {
      const elm = document.querySelector("#" + ID);

      if (elm) {
        elm.style.position = "relative";
        if (Page.emAll) elm.appendChild(Page.emAll);
        this.GG.containerID = ID;
        Page.emContainer = elm;
      }
    }

    sha256(dataObj) {
      const bsv = window.bsv;
      let hash1 = bsv.crypto.Hash.sha256(bsv.deps.Buffer(dataObj)).toString("hex");
      return hash1;
    }

    verify(data_hash, strSig, strPubKey) {
      const bsv = window.bsv;
      let sig = bsv.crypto.Signature.fromString(strSig);
      let pubKey = bsv.PublicKey.fromString(strPubKey);
      let hash2 = bsv.crypto.Hash.sha256(bsv.deps.Buffer.from(data_hash, "hex"));
      return bsv.crypto.ECDSA.verify(hash2, sig, pubKey);
    }

    getSupportedWallets() {
      return ["vbox", "dot"];
    }

    genQRImg(options, imgID, cb) {
      this.cb = cb;
      loadScript("https://cdnjs.cloudflare.com/ajax/libs/qrcode-generator/1.4.4/qrcode.min.js").then(() => {
        this._preHandleOptions(options);

        const strQR = this.genQRString(options);
        var typeNumber = 0;
        var errorCorrectionLevel = "L";
        var qr = qrcode(typeNumber, errorCorrectionLevel);
        qr.addData(strQR);
        qr.make();
        let strImgTag = qr.createDataURL(4);
        document.getElementById(imgID).src = strImgTag;
        this.start_checker();
      });
    }

    genQRString(options) {
      let req = null;

      if (options.pay_request) {
        req = options.pay_request;
      }

      if (options.sign_request) {
        req = options.sign_request;
      }

      if (req.url == null) {
        //const domain = document.location.origin;
        const saveURL = relayServer + "relay/save";
        const getURL = relayServer + "relay/get/";
        const reqBody = req.data;
        reqBody.notify_url = relayServer + "relay/notify";
        fetch(saveURL, {
          method: "post",
          headers: {
            Accept: "application/json, text/plain, */*",
            "Content-Type": "application/json"
          },
          body: JSON.stringify(reqBody)
        }).then(function (response) {
          //log(response);
          return response.json();
        }).then(function (data) {
          log("reply from save_pr:", data);
        }); //req.url = getURL+reqBody.id;

        const url = getURL + reqBody.id;
        const newOption = options.pay_request ? {
          pay_request: {
            url: url
          }
        } : {
          sign_request: {
            url: url
          }
        };
        return JSON.stringify(newOption);
      }

      return null;
    }

    _preHandleOptions(options) {
      this.GG.options = options;
      let req = {};
      if (options.pay_request) req = options.pay_request;
      if (options.sign_request) req = options.sign_request;
      const data = req.data;
      /*if (data.to) {
        for (let i = 0; i < data.to.length; i++) {
          const item = data.to[i];
          if (item.data) {
            const script_data = window.nbpay.data2script(item.data).toHex();
            item.script = script_data;
            item.value = 0;
            delete item.data;
          }
        }
      }*/

      if (!data.product) data.product = this.GG.product;
      if (!data.expire) data.expire = Date.now() + this.GG.timeout * 1000;
      if (!data.id) data.id = Date.now().toString();
      if (!data.v) data.v = 2;
      if (!data.app) data.app = this.GG.app;
      log(JSON.stringify(options));
    }

    start_checker() {
      //start checker
      const body = this.GG.options.pay_request ? this.GG.options.pay_request.data : this.GG.options.sign_request.data;
      this.GG.current_orderID = body.id;

      if (this.GG.current_orderID) {
        const timeoutID = setTimeout(this.checkReturn.bind(this), 2000, this.GG.current_orderID);
        log("checker started, timeoutID:", timeoutID);
        this.GG.expireObj[this.GG.current_orderID] = {
          expire: body.expire,
          timeoutID: timeoutID
        };
      }
    }

    _show(code) {
      if (g_isBrowser) Page.emAll.style.display = 'block';else {
        const qrterminal = require('qrcode-terminal');

        qrterminal.generate(code, {
          small: true
        });
      }
    }

    request(options, cb) {
      if (options.containerID) this.GG.containerID = options.containerID;
      this.cb = cb;

      this._preHandleOptions(options);

      log("opay options:", options);
      const QRString = this.genQRString(options);

      if (this.GG.wallet) {
        this.callWallet(this.GG.wallet);
        return;
      }

      if (!this.GG.wallet) {
        //No wallet specified
        this._setupUI(QRString);

        this._show(QRString);
      }

      this.start_checker();
    }

    callWallet(name) {
      if (name === "dot") {
        let url = "https://www.ddpurse.com/wallet/open/nbdomain?opp=";
        url += encodeURIComponent(QRString);
        window.open(url, this.GG.current_orderID);
        this.start_checker();
        this.GG.usedWallet = name;
      }

      if (name === "vbox") {
        if (typeof VBox == 'undefined') {
          window.open("https://www.maxthon.com", "_about:blank");
          return;
        }

        let vbox_option = this.GG.options.pay_request ? {
          pay_request: {
            data: JSON.stringify(this.GG.options.pay_request.data)
          }
        } : {
          sign_request: {
            data: JSON.stringify(this.GG.options.sign_request.data)
          }
        };
        this.GG.usedWallet = name;
        log("calling vbox with options:", vbox_option);
        VBox.Request(vbox_option, data => {
          this.handle_result(true, data);
        });
      }
    }

  }

  return Opay2;

}));
